<template>
    <f7-page name="accountform" 
        @page:beforein="onPageBeforeIn">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false">
            <f7-nav-left back-link></f7-nav-left>
            <f7-nav-title>My Account</f7-nav-title>
		</f7-navbar>
      
        <f7-list no-hairlines class="no-margin">
            <f7-list-input
				ref="fullname"
				label="Full name"
				placeholder="Full name"
				maxlength="45"
				clear-button
				:value="accountForm.fullname"
				@input="accountForm.fullname = $event.target.value">
			</f7-list-input>
            <f7-list-input
				ref="badge"
				label="Company Badge Number"
				placeholder="Badge number"
                type="number"
				clear-button
				:value="accountForm.badge"
				@input="accountForm.badge = $event.target.value">
			</f7-list-input>
            <f7-list-input
				ref="phone"
				label="Mobile Phone"
                placeholder="081xxxxxxxxx"
                type="number"
				:value="accountForm.phone"
				@input="accountForm.badge = $event.target.value">
			</f7-list-input>
        </f7-list>
        <f7-block>
            <f7-button class="button-orange" @click="doSubmit" fill large>Update</f7-button>
        </f7-block>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { parseError, validPhone } from '../js/utils';
export default {
    name: 'AccountForm',
    data(){
        return {
            accountForm: {
                fullname: '',
                badge: '',
                phone: ''
            }
        };
    },
    computed: {
        ...mapGetters('auth', ['user'])
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;
    },
    methods: {
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            self.accountForm.fullname = self.user.fullname;
            self.accountForm.badge = self.user.badge;
            self.accountForm.phone = self.user.phone;
        },
        doSubmit(){
            const self = this;
			const app = self.$f7;

			if(self.accountForm.fullname.length == 0){
				app.dialog.alert('Full name is required', 'Doctrin');
				return false;
			}else if(/^([a-zA-Z\s]{1,45})$/.test(self.accountForm.fullname) == false){
				app.dialog.alert('Full name length maximum 45 characters. Only letters, numbers and spaces area allowed', 'Doctrin');
				return false;
			}else if(validPhone(self.accountForm.phone) == false){
				app.dialog.alert('Invalid mobile phone number', 'Doctrin');
				return false;			
			}

			app.preloader.show('red');

			let params = {};

			params.fullname = self.accountForm.fullname;
            params.badge = self.accountForm.badge;
            params.phone = self.accountForm.phone;

			self.$store.dispatch('auth/updateMe', params).then((response) => {
				app.preloader.hide();

                if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'Doctrin');
					return false;
				}else{
					self.$f7router.back({
						ignoreCache: true
					});
				}
			});
        }
    },

}
</script>
